﻿using IRaCIS.Core.Domain.Share;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IRaCIS.Core.Application.Service.Reading.Dto
{

    public class AutoAddClinicalInDto
    {
		public Guid? SubjectId { get; set; }

		//public Guid? VisitId { get; set; }

		public Guid TrialId { get; set; }
	}


	public class GetCRCSubjectClinicalInDto
    {
        public Guid TrialId { get; set; }
    }


    public class GetCRCSubjectClinicalOutDto
    {
		public Guid SubjectId { get; set; }

		public Guid TrialId { get; set; }

		public string SubjectCode { get; set; }
		public Guid ClinicalDataTrialSetId { get; set; }

        public string ClinicalDataSetName { get; set; }

		public string ClinicalDataSetEnName { get; set; }

		public int ClinicalCount { get; set; } = 0;
    }


    public class GetCRCSubjectClinicalResultDto
    {
        public Guid SubjectId { get; set; }

        public string SubjectCode { get; set; }

        public List<GetCRCSubjectClinicalOutDto> ClinicalDataList { get; set; }
	}




	public class GetClinicalQuestionAnswerListInDto
    {
        public Guid SubjectId { get; set; }


		public Guid TrialId { get; set; }

		public Guid ClinicalDataTrialSetId { get; set; }
    }


    public class GetClinicalQuestionAnswerListOutDto
    {
        public List<TrialClinicalQuestionDto> QuestionList { get; set; }

        public List<Dictionary<string, string>> AnswerList { get; set; }
    }

    public class GetClinicalFormInfoInDto
    {
        public Guid ClinicalFormId { get; set; }
    }

    public class GetClinicalFormInfoOutDto
    {
        public List<ClinicalQuestionPreviewDto> Question { get; set; }
    }

    public class ClinicalFormQuestionAnswer
    {
        public Guid QuestionId { get; set; }

        public string Answer { get; set; } = string.Empty;
    }

    public class ClinicalFormTableQuestionAnswer
    {
        public Guid TableQuestionId { get; set; }

        public int RowIndex { get; set; }

        public Guid QuestionId { get; set; }

        public string Answer { get; set; } = string.Empty;
    }

    public class GetCRCConfirmListInDto
    {
		public Guid TrialId { get; set; }
	}

    public class CRCCancelConfirmClinicalInDto
    {
		public Guid TrialId { get; set; }

		public Guid ReadModuleId { get; set; }
	}

	public class CRCConfirmClinicalInDto
    {
		public Guid TrialId { get; set; }

		public Guid ReadModuleId { get; set; }
	}


	public class CRCClinicalForm
    {
		public DateTime? CkeckDate { get; set; }

        public Guid ClinicalFormId { get; set; }

		/// <summary>
		/// 临床级别
		/// </summary>
		public ClinicalLevel ClinicalDataLevel { get; set; }
	}


	public class GetCRCConfirmListOutDto
    {

		/// <summary>
		/// 受试者ID
		/// </summary>
		public Guid SubjectId { get; set; }
		public Guid ReadModuleId { get; set; }

		public bool IsPMConfirm { get; set; }

		public ReadingSetType ReadingSetType { get; set; }

		public bool IsCRCConfirm { get; set; } = false;

		/// <summary>
		/// 最晚拍片日期
		/// </summary>
		public DateTime? LatestScanDate { get; set; }


        public List<Guid> ClinicalFormIdList { get; set; }

		public int FormCount
		{
			get
			{
				return this.ClinicalFormIdList.Count();
			}
		}
	}

    public class DeleteClinicalFormInDto
    {
		public Guid ClinicalFormId { get; set; }
	}
	public class SubmitClinicalFormInDto
    {
        /// <summary>
        /// VisitId
        /// </summary>
        public Guid? VisitId { get; set; }

        /// <summary>
        /// VisitId
        /// </summary>
        public Guid? ReadingId { get; set; }

        public Guid? ClinicalFormId { get; set; }

        public Guid SubjectId { get; set; }

		public Guid TrialId { get; set; }

		public Guid ClinicalDataTrialSetId { get; set; }


        public List<ClinicalFormQuestionAnswer> QuestionAnswers { get; set; }

        public List<ClinicalQuestionForm> TableQuestionAnswerList { get; set; }
    }


    public class ClinicalQuestionForm
    {
        public Guid QuestionId { get; set; }

        public List<List<ClinicalTableQuestionForm>> TableQuestionAnswers { get; set; }
    }


    public class ClinicalTableQuestionForm
    {
        public Guid TableQuestionId { get; set; }

        public string Answer { get; set; } = string.Empty;
    }
}
